package com.huimv.farm.damsubsidy.controller;

import com.huimv.farm.damsubsidy.common.utils.AreaUtil;
import com.huimv.farm.damsubsidy.common.utils.Result;
import com.huimv.farm.damsubsidy.common.utils.ResultCode;
import com.huimv.farm.damsubsidy.service.IAreaByLevelService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.List;
import java.util.Map;


// Author: Tinger-XXX
// Time: 2023/5/6 18:43
@RestController
@RequestMapping("/area")
public class AreaByLevelController {
    @Autowired
    private IAreaByLevelService areaByLevelService;

    private final List<Integer> idLengths = Arrays.asList(2, 4, 6, 9, 12);

    @GetMapping("/types")
    public Result listTypes() {
        return areaByLevelService.listTypes();
    }

    @GetMapping("/levels")
    public Result listLevels() {
        return areaByLevelService.listLevels();
    }

    @GetMapping("/info")
    public Result getInfo() {
        return areaByLevelService.getInfo();
    }

    @GetMapping("/provinces")
    public Result listProvinces() {
        return areaByLevelService.listProvinces();
    }

    @PostMapping("/children_of")
    public Result listChildrenOf(@RequestBody Map<String, String> map) {
        String curId = map.get("cur_id"), child = map.get("child");
        if (curId == null || child == null)
            return new Result(10002, "key param lost", false);
        boolean include = AreaUtil.include(idLengths, curId.length());
        if (!include || child.length() != 2)
            return new Result(10002, "error params", false);

        if (curId.length() == 12) return new Result(10002, "no more children", false);
        return areaByLevelService.listChildrenOf(curId, child);
    }
}
